mod Ex07

incl Mtex

incl Mtexar

incl Maux

loc rem 
  \para \bf  7. CVICENIE Z PREDMETU 1-INF-465 DEKLARATIVNE PROGRAMOVANIE  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end utorok 1.4.2008 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-465-dp/0708ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane poliam. Zadanie sa 
  sklada z tychto suborov: 
  \items 
   \item \para Subory \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subory \it  maux*.cl  \end obsahuju definicie niektorych funkcii 
         a predikatov. 
   \item \para Subory \it  ex*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] Remark.  \end The module \it  Msyntax  \end in the file \it  
  msyntax.cl  \end contains the syntax of the system CL. 

rem 
  \para \bf  Chapter. Programs Operating on Arrays.  \end 

rem 
  \para \bf  Section. Formalization of Arrays.  \end See also the module \it  
  Maux  \end. 

rem 
  \para \bf  Section. Programming with Arrays.  \end 

rem 
  \para \bf  Filling an array.  \end \header* fun/3 Fill  \end Define the 
  function \ft Fill(a,n,x) \end such that 
  \eq* 
    A(a,n) -> A(Fill(a,n,x),n)
  \end
  \eq* 
    A(a,n) & i < n -> Sub(Fill(a,n,x),i) = x
  \end
  \para \it  Hint.  \end \header* fun/4 Fill1 'Tex_f4_f' \end Define first an 
  auxiliary function \ft Fill1(a,k,n,x) \end satisfying the following invariant: 
  \eq* 
    A(a,n) & k <= n -> Fill1(a,k,n,x) = Sba(a,0,k)++Fill(Sba(a,k,n),n-k,x)
  \end

fun/4 Fill1 'Tex_f4_f'
  Fill1(a,k,n,x) = Foo

fun/3 Fill 
  Fill(a,n,x) = Foo

rem 
  \para \bf  Binary search.  \end \header* pred/3 Bsearch  \end Find an 
  efficient implementation of the array membership predicate for ordered arrays. 
  That is, define the predicate \ft Bsearch(x,a,n) \end such that 
  \eq* 
    A(a,n) & Ord(a) -> Bsearch(x,a,n) <-> x in a
  \end
  \para \it  Hint.  \end \header* pred/4 Bsearch1 'Tex_p4_p' \end Define first 
  an auxiliary predicate \ft Bsearch1(x,a,k,m) \end such that 
  \eq* 
    A(a,n) & Ord(a) & k <= m & m <= n -> Bsearch1(x,a,k,m) <-> x in Sba(a,k,m)
  \end
  \para Note that the condition of regularity follows from 
  \eq* 
    k < m -> k <= (k+m)/2 & (k+m)/2 < m
  \end

pred/4 Bsearch1 'Tex_p4_p'
  Bsearch1(x,a,k,m) <-> Poo

pred/3 Bsearch 
  Bsearch(x,a,n) <-> Poo

rem 
  \para \bf  The Dutch national flag problem.  \end Let 
  \def 
    pred Red 
    Red(a) <-> \a i(i < L(a) -> Sub(a,i) < 1)
  \end
  \def 
    pred White 
    White(a) <-> 
      \a i(i < L(a) -> Sub(a,i) = 1)
  \end
  \def 
    pred Blue 
    Blue(a) <-> 
      \a i(i < L(a) -> Sub(a,i) > 1)
  \end
  \def 
    pred Dutch 
    Dutch(a) <-> 
      \e r\e b(r <= b & b <= L(a) & Red Sba(a,0,r) & White Sba(a,r,b) & 
               Blue Sba(a,b,L(a)))
  \end
  \para \header* fun/2 Dsort  \end Define the function \ft Dsort(a,n) \end such 
  that 
  \eq* 
    A(a,n) -> A(Dsort(a,n),n)
  \end
  \eq* 
    A(a,n) -> Perm(Dsort(a,n),a)
  \end
  \eq* 
    A(a,n) -> Dutch Dsort(a,n)
  \end
  \para \it  Hint.  \end \header* fun/4 Dsort1 'Tex_f4_f' \end Define first an 
  auxiliary function \ft Dsort1(a,r,w,b) \end such that 
  \eq* 
    A(a,n) & r <= w & w <= b & b <= n -> A(Dsort1(a,r,w,b),n)
  \end
  \eq* 
    A(a,n) & r <= w & w <= b & b <= n -> Perm(Dsort1(a,r,w,b),a)
  \end
  \eq* 
    A(a,n) & r <= w & w <= b & b <= n & Red Sba(a,0,r) & White Sba(a,r,w) & 
    Blue Sba(a,b,n) -> Dutch Dsort1(a,r,w,b)
  \end

fun/4 Dsort1 'Tex_f4_f'
  Dsort1(a,r,w,b) = Foo

fun/2 Dsort 
  Dsort(a,n) = Foo

rem 
  \para \bf  Quicksort.  \end \header* fun/2 Qsort  \end Implement the quicksort 
  algorithm. That is, define the function \ft Qsort(a,n) \end such that 
  \eq* 
    A(a,n) -> A(Qsort(a,n),n)
  \end
  \eq* 
    A(a,n) -> Perm(Qsort(a,n),a)
  \end
  \eq* 
    A(a,n) -> Ord Qsort(a,n)
  \end
  \para \it  Hint.  \end \header* fun/3 Qsort1 'Tex_f3_f' \end Define first an 
  auxiliary function \ft Qsort1(a,k,m) \end satisfying the following invariant: 
  \eq* 
    A(a,n) & k <= m & m <= n -> 
    Qsort1(a,k,m) = Sba(a,0,k)++Qsort(Sba(a,k,m),m-k)++Sba(a,m,n)
  \end

fun/5 Pt 'Tex_f5_partition'
  Pt(a,r,w,b,p) = Foo

fun/3 Qsort1 'Tex_f3_f'
  Qsort1(a,k,m) = Foo

rem 
  \para Note that we have 
  \eq* 
    Pt(a,r,w,b,p) = a1,r1,b1 -> r <= r1 & b1 <= b
  \end
  \eq* 
    r < w & w <= b & Pt(a,r,w,b,p) = a1,r1,b1 -> r1 < b1
  \end
  \para Therefore 
  \eq* 
    k < m & Pt(a,k,k+1,m,Sub(a,k)) = a1,r,b -> k <= r & r < b & b <= m
  \end
  \para This proves the conditions of regularity for \ft Qsort1(a,k,m) \end. 

fun/2 Qsort 
  Qsort(a,n) = Foo

